/*
 * See the NOTICE file distributed with this work for additional
 * information regarding copyright ownership.
 *
 * This is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Lesser General Public License as
 * published by the Free Software Foundation; either version 2.1 of
 * the License, or (at your option) any later version.
 *
 * This software is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this software; if not, write to the Free
 * Software Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA
 * 02110-1301 USA, or see the FSF site: http://www.fsf.org.
 */
package org.xwiki.captcha.internal;

import org.xwiki.component.annotation.Component;

import com.octo.captcha.service.sound.SoundCaptchaService;
import com.octo.captcha.service.sound.DefaultManageableSoundCaptchaService;

/**
 * The DefaultSoundCaptchaAction creates a wav file with a word which is spelled
 * out loud by a speech synthesizer.
 * 
 * @version $Id: d152c568ea601ea31693d9b1b7db6bf547394805 $
 * @since 2.2M2
 */
@Component("sound")
public class DefaultSoundCaptchaAction extends AbstractSoundCaptchaAction
{
    /** The service which provides the captcha, must be static because struts instanciates per request. */
    private static final SoundCaptchaService SERVICE = new DefaultManageableSoundCaptchaService();

    /**
     * {@inheritDoc}
     *
     * @see AbstractCaptchaAction#getCaptchaService()
     */
    SoundCaptchaService getCaptchaService()
    {
        return SERVICE;
    }
}
