/*
 * See the NOTICE file distributed with this work for additional
 * information regarding copyright ownership.
 *
 * This is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Lesser General Public License as
 * published by the Free Software Foundation; either version 2.1 of
 * the License, or (at your option) any later version.
 *
 * This software is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this software; if not, write to the Free
 * Software Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA
 * 02110-1301 USA, or see the FSF site: http://www.fsf.org.
 */
package org.xwiki.rest.resources;

import javax.ws.rs.GET;
import javax.ws.rs.Path;

import org.xwiki.component.annotation.Component;
import org.xwiki.rest.Utils;
import org.xwiki.rest.XWikiResource;
import org.xwiki.rest.model.jaxb.Syntaxes;

/**
 * @version $Id: 656760f59772e218a9d44641ea300a7758663c4f $
 */
@Component("org.xwiki.rest.resources.SyntaxesResource")
@Path("/syntaxes")
public class SyntaxesResource extends XWikiResource
{
    @GET
    public Syntaxes getSyntaxes()
    {
        Syntaxes syntaxes = objectFactory.createSyntaxes();
        syntaxes.getSyntaxes().addAll(Utils.getXWiki(componentManager).getConfiguredSyntaxes());

        return syntaxes;
    }
}
