/*
 * See the NOTICE file distributed with this work for additional
 * information regarding copyright ownership.
 *
 * This is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Lesser General Public License as
 * published by the Free Software Foundation; either version 2.1 of
 * the License, or (at your option) any later version.
 *
 * This software is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this software; if not, write to the Free
 * Software Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA
 * 02110-1301 USA, or see the FSF site: http://www.fsf.org.
 */
package org.xwiki.url.internal.standard;

import org.xwiki.component.annotation.Component;
import org.xwiki.model.reference.WikiReference;
import org.xwiki.url.standard.HostResolver;

/**
 * Find wiki name based on the path value representing the wiki in a Path-based setup.
 *
 * @version $Id: 6a55f09cc22b88ed6007e4612d6822c55ef49467 $
 * @since 3.0M3
 */
@Component("path")
public class PathBasedHostResolver implements HostResolver
{
    /**
     * {@inheritDoc}
     */
    public WikiReference resolve(String host)
    {
        return new WikiReference(host.toLowerCase());
    }
}
